Bug 229345 - [GFS2] NFS fix - gfs2_decode_fh
[GFS2] NFS fix - gfs2_decode_fh
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: kernel (Show other bugs)
All Linux
medium Severity medium
: ---
: ---
Assigned To: Wendy Cheng
GFS Bugs
Depends On:
Blocks: 204760 229346
  Show dependency treegraph
Reported: 2007-02-20 10:06 EST by Wendy Cheng
Modified: 2007-11-30 17:07 EST (History)
5 users (show)

See Also:
Fixed In Version: RHBA-2007-0959
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2007-11-07 14:40:52 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description Wendy Cheng 2007-02-20 10:06:51 EST
Description of problem:
GFS(s) expects NFS fh_type and fh_len would have the same value. 
This is apparently not correct. One obvious symptom is that 
it will fail NFS V2 (which uses fixed fh_len for all requests) 
mount command. 

Version-Release number of selected component (if applicable):

How reproducible:
Depending on NFS request types - for v2 mount command, it fails
each time and every time.

Steps to Reproduce:
Mount GFS(s) partitions on NFS clients using NFS v2 protocol. 

Actual results:
The command fails with ESTALE error.

Expected results:
Mount succeeds. 

Additional info:
Patch has submitted to cluster-devel list.
Comment 1 Wendy Cheng 2007-02-23 12:43:18 EST
Patch submiited via:


In Steve's git tree on 02/23/07. 
Comment 2 RHEL Product and Program Management 2007-03-01 16:47:04 EST
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
Comment 3 Kiersten (Kerri) Anderson 2007-03-09 13:40:22 EST
Devel ACK for 5.1 - Would like to get into an early 5.1 cycle kernel build.
Comment 4 RHEL Product and Program Management 2007-03-09 18:58:59 EST
This request was evaluated by Red Hat Kernel Team for inclusion in a Red
Hat Enterprise Linux maintenance release, and has moved to bugzilla 
status POST.
Comment 5 Don Zickus 2007-04-17 16:01:43 EDT
in 2.6.18-15.el5
Comment 7 Mike Gahagan 2007-09-12 15:20:08 EDT
It looks like we can now nfsv2 mount gfs filesystems, but once mounted it still
looks like we have problems:

[root@test158 mnt]# mount test183.test.redhat.com:/mnt/gfstest /mnt/test -o vers=2
[root@test158 mnt]# cd /mnt/test
[root@test158 test]# ls
[root@test158 test]# touch test
touch: setting times of `test': Stale NFS file handle
[root@test158 test]# ls -R
linux-2.6.18.i686  test
ls: reading directory ./linux-2.6.18.i686: Input/output error

[root@test158 test]# cat /proc/mounts | grep test183
test183.test.redhat.com:/mnt/gfstest /mnt/test nfs
0 0

Everything looked fine with nfsv3
Comment 8 Mike Gahagan 2007-09-12 15:23:18 EDT
Testing described in comment 7 was done with an i386 system running the -45
kernel hosting the gfs2 fs and acting as the nfs server. The nfs client machine
was x86_64 and running the -46 xen kernel.
Comment 9 Wendy Cheng 2007-09-12 15:57:56 EDT
Yes, nfs v3 does work but nfs v2 has been broken. It is not a high priority
at this moment. 
Comment 10 Mike Gahagan 2007-09-12 16:04:53 EDT
I tried the same test as in comment 7 with the rhel5 ga kernel and didn't see
any difference in behavior.. i.e. the mount itself still succeds, however the
mounted fs isn't usable. 

I'm not sure if this matches the exact behavior from before (the description
seems to imply that the mount command itself fails). Please advise if a new bug
should be  opened to describe this behavior.

The good news is that nfs3 apperantly works with the -45 kernel (it panics my
system with -8)
Comment 11 Kiersten (Kerri) Anderson 2007-09-12 16:25:53 EDT
Open a new bug for nfs v2 - mark this bug as verified
Comment 13 errata-xmlrpc 2007-11-07 14:40:52 EST
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.


Note You need to log in before you can comment on or make changes to this bug.